Index: iputils-20210202/arping.c
===================================================================
--- iputils-20210202.orig/arping.c
+++ iputils-20210202/arping.c
@@ -94,7 +94,8 @@ struct run_state {
 		senduntagged:1,
 		untagged:1,
 		strict:1,
-		sockraw:1;
+		sockraw:1,
+		maczeros:1;
 	uint16_t tagged;
 };
 
@@ -168,6 +169,7 @@ static void usage(void)
 		"\nUsage:\n"
 		"  arping [options] <destination>\n"
 		"\nOptions:\n"
+		"  -0            use zeros for unspecified mac addresses instead of ones\n"
 		"  -f            quit on first reply\n"
 		"  -q            be quiet\n"
 		"  -b            keep on broadcasting, do not unicast\n"
@@ -480,6 +482,8 @@ static int send_pack(struct run_state *c
 
 	if (ctl->advert)
 		memcpy(p, &ME->sll_addr, ah->ar_hln);
+	else if (ctl->maczeros)
+		memset(p, 0, ah->ar_hln);
 	else
 		memcpy(p, &HE->sll_addr, ah->ar_hln);
 	p += ah->ar_hln;
@@ -1168,7 +1172,7 @@ int main(int argc, char **argv)
 	textdomain (PACKAGE_NAME);
 #endif
 #endif
-	while ((ch = getopt(argc, argv, "h?bfDuUAqC:c:w:i:Ss:I:VtT:p:")) != EOF) {
+	while ((ch = getopt(argc, argv, "0h?bfDuUAqC:c:w:i:Ss:I:VtT:p:")) != EOF) {
 		switch (ch) {
 		case 'b':
 			ctl.broadcast_only = 1;
@@ -1183,6 +1187,9 @@ int main(int argc, char **argv)
 		case 'U':
 			ctl.unsolicited = 1;
 			break;
+		case '0':
+			ctl.maczeros = 1;
+			break;
 		case 'A':
 			ctl.advert = 1;
 			ctl.unsolicited = 1;
